/**
 * Reception et affichage des donnees d'un telemetre a ultrasons simple Interface-Z
 * Receiving and displaying data from a Midi ultrasound rangefinder
 */
import promidi.*;
MidiIO midiIO;


void setup()
{
  midiIO = MidiIO.getInstance(this);
  println("<<<<<<<<< Ports Midi >>>>>>>>>");
  midiIO.printDevices();
  midiIO.openInput(0,0);  

  PFont fontA = loadFont("CourierNew36.vlw");
  textFont(fontA, 24);

  size(300, 300, P3D);
  background(0);
  noStroke();

}

int[] valeur = new int[2]; 
int telemetre;
int[] registre = new int[28]; 

// Reception des donnees des capteurs.
// Receiving sensors data.
void controllerIn(Controller controller, int device, int channel){
  int numero = controller.getNumber();

  if (numero == 2){
    valeur[0] = controller.getValue();
  }    
  if (numero == 3) {
    valeur[1] = controller.getValue();
    telemetre = valeur[1] + (valeur[0] << 7);   
  }
  /* Mise en memoire des 20 dernieres valeurs au cours du temps.
   * Memorising the last 20 data.
   */
  for (int i = 27; i > 0; i = i-1) {
    registre[i]=registre[i-1];
  }
  registre[0]=telemetre;
}

/* Affichage des donnees du telemetre.
 * Displaying rangefinder data.
 */

void draw()
{
  background(0);
  fill(255);
  color coul_asc = color(212, 255, 106);
  color coul_barre = color(100, 10, 100); 

  fill(coul_asc);
  rect(10, 0, 280, 256); 

  fill(coul_barre);

  for (int i = 0; i < 28; i = i+1) {

    if (telemetre < 3500) {
      //  rect(10, 254-(telemetre * 0.073), 30, 2); 
      rect((i+1)*10, 254-(registre[i]* 0.073), 9, (registre[i]* 0.073)+2);
    }
    if (telemetre >= 3500) {
      //  rect(10, 0, 30, 2);
      rect((i+1)*10, 0, 9, 256);   
    }      

  }

  fill(255);
  text("Tlmtre Midi", 80, 285);
  text(telemetre, 10, 285);
}


